//=========================================================
//
// AvP[V{́ij
//
//=========================================================

#include "Application.h"
#include "DirManager.h"
#include "ImageView.h"
#include "Button.h"
#include <Windows.h>

#include <string>

using namespace std;

//=========================================================
// RXgN^
//=========================================================
Application::Application ( string appDir ) {

	// AṽfBNg擾
	_appdDir = appDir;

	// EBhE𐶐
	sf::ContextSettings settings;
	_window.create (sf::VideoMode(600, 400), "A-Viewer", sf::Style::Default, settings);
	_window.setVerticalSyncEnabled(true);

	_defaultView = _window.getDefaultView();

	_dirManager = new DirManager();
	_imageView  = new ImageView(_window);

	_isMousePressing = false;
	_isMouseOn       = false;
	_isFullScreen    = false;

	// {^𐶐
	_arrow_Left  = new Button ( _appdDir + "\\resource\\arrow_left.png" );
	_arrow_Right = new Button ( _appdDir + "\\resource\\arrow_right.png" );



	AdjustArrowPosition();
}

//=========================================================
// fXgN^
//=========================================================
Application::~Application() {

	delete _dirManager;
	delete _imageView;
	delete _arrow_Left;
	delete _arrow_Right;
}

//=========================================================
// Avs
//yz
// NɃhbvꂽt@CiR}hCj
//=========================================================
void Application::Run ( string dropPath ) {

	///// NɃt@Chbv
	if ( dropPath != "" ) {

		_dirManager->Drop ( dropPath );
		_imageView->SetImage ( _dirManager->GetCurrentImageFilePath() );
		_window.setTitle ( _dirManager->GetCurrentImageFileName() );

		CenterImage ( false );
		//FitWindowToImage();
	}

	///// Cxg[v
    while (_window.isOpen()) {

        sf::Event event;
        while (_window.pollEvent(event))
        {
            if (event.type == sf::Event::Closed) {
                _window.close();
			}
			
			///// t@Chbv
			if (event.type == sf::Event::FileDrop) {
				
				string fileName = event.fileDropEvent.fileName;

				_dirManager->Drop ( fileName );
				_imageView->SetImage ( _dirManager->GetCurrentImageFilePath() );
				_window.setTitle ( _dirManager->GetCurrentImageFileName() );

				// hbvłƂƂ̓tXN[ł͂Ȃ͂
				CenterImage ( false );
				//FitWindowToImage();
			}
			

			///// TCYCxgLb`
			if (event.type == sf::Event::Resized)
			{
				// r[̃TCYEBhE̐VTCYɍ킹
				AdjustViewToWindowSize();

				// ̈ʒu𒲐
				AdjustArrowPosition();
			}

			///// }EX̃{^
			if (event.type == sf::Event::MouseButtonPressed) 
			{
				///// {^
				if ( event.mouseButton.button == sf::Mouse::Left ) {
					_isMousePressing = true;
					_mouseX = sf::Mouse::getPosition().x;
					_mouseY = sf::Mouse::getPosition().y;
				}

			}

			///// }EX̃{^𗣂
			if (event.type == sf::Event::MouseButtonReleased) 
			{
				///// {^𗣂
				if ( event.mouseButton.button == sf::Mouse::Left ) {
					_isMousePressing = false;
				}

				///// E{^𗣂
				if ( event.mouseButton.button == sf::Mouse::Right ) {

					CenterImage ( true );
					//FitWindowToImage();
				}
				///// ^񒆂̃{^𗣂
				if ( event.mouseButton.button == sf::Mouse::Middle ) {

					//_imageView->ZoomReset();
					Switch_FillScreenWindow();
				}

			}

			///// }EX𓮂
			if (event.type == sf::Event::MouseMoved)
			{
				if ( _isMousePressing ) {

					// ړʂ߂
					int moveX = _mouseX - sf::Mouse::getPosition().x;
					int moveY = _mouseY - sf::Mouse::getPosition().y;

					// r[XN[
					sf::View view = _window.getView();
					sf::Vector2f currentCenter = view.getCenter();
					currentCenter.x += moveX;
					currentCenter.y += moveY;
					view.setCenter ( currentCenter );
					_window.setView( view );

					// ݈ʒuXV
					_mouseX = sf::Mouse::getPosition().x;
					_mouseY = sf::Mouse::getPosition().y;
				}

			}

			///// zC[
			if (event.type == sf::Event::MouseWheelMoved) 
			{
				if ( _isMouseOn ) {
					printf ("%d\n", event.mouseWheel.delta);

					if ( event.mouseWheel.delta > 0 ) {
						_imageView->ZoomIn();
					}
					if ( event.mouseWheel.delta < 0 ) {
						_imageView->ZoomOut();
					}

				}

			}

			///// EBhEɏǂ
			if (event.type == sf::Event::MouseEntered) {
				_isMouseOn = true;
			}
			if (event.type == sf::Event::MouseLeft) {
				_isMouseOn = false;
				_isMousePressing = false;
			}

			///// L[
			if (event.type == sf::Event::KeyPressed) {

				// 
				if (event.key.code == sf::Keyboard::Left)
				{
					_dirManager->Prev();
					_imageView->SetImage ( _dirManager->GetCurrentImageFilePath());
					_window.setTitle ( _dirManager->GetCurrentImageFileName() );

				}
				// E
				if (event.key.code == sf::Keyboard::Right)
				{
					_dirManager->Next();
					_imageView->SetImage ( _dirManager->GetCurrentImageFilePath());
					_window.setTitle ( _dirManager->GetCurrentImageFileName() );

				}
			}

        } // Cxg[v̕


		// t[̉ʃNABwiFύXƂ́AGB
		_window.clear ( sf::Color ( 200,200,200,255 ) );

		// 摜`
		_imageView->Draw ( _window );

		// GUIii{^j\鏀Br[ftHgɖ߂B
		sf::View activeView = _window.getView();
		_window.setView ( _defaultView );
		
		// ` & mF
		_arrow_Left-> Draw ( _window );
		if (_arrow_Left->IsClick()) {
			printf ("Left NbN\n");

			_dirManager->Prev();
			_imageView->SetImage ( _dirManager->GetCurrentImageFilePath() );
			_window.setTitle ( _dirManager->GetCurrentImageFileName() );

		}
		
		// E` & mF
		_arrow_Right->Draw ( _window );
		if (_arrow_Right->IsClick()) {
			printf ("Right NbN\n");

			_dirManager->Next();
			_imageView->SetImage ( _dirManager->GetCurrentImageFilePath() );
			_window.setTitle ( _dirManager->GetCurrentImageFileName() );
		}
		

		// r[߂
		_window.setView ( activeView );


		// `s
        _window.display();
	}

}

//=========================================================
// ̈ʒuEBhE̗[ɍ킹
//=========================================================
void Application::AdjustArrowPosition () {

	sf::Vector2f arrowLeftPos;
	arrowLeftPos.x = _window.getSize().x / 2.0f - _arrow_Left->GetSize().x / 2.0f;
	arrowLeftPos.y = _window.getSize().y - _arrow_Left->GetSize().y / 2.0f;
	_arrow_Left->SetPosition ( arrowLeftPos );

	sf::Vector2f arrowRightPos;
	arrowRightPos.x = _window.getSize().x / 2.0f + _arrow_Right->GetSize().x / 2.0f;
	arrowRightPos.y = _window.getSize().y - _arrow_Right->GetSize().y / 2.0f;
	_arrow_Right->SetPosition ( arrowRightPos );

	///// [ɔzu
	/*
	sf::Vector2f arrowLeftPos;
	arrowLeftPos.x = _arrow_Left->GetSize().x / 2.0f;
	arrowLeftPos.y = _window.getSize().y / 2.0f;
	_arrow_Left->SetPosition ( arrowLeftPos );

	sf::Vector2f arrowRightPos;
	arrowRightPos.x = _window.getSize().x - _arrow_Right->GetSize().x / 2.0f;
	arrowRightPos.y = _window.getSize().y / 2.0f;
	_arrow_Right->SetPosition ( arrowRightPos );
	*/
}


//=========================================================
// r[̃TCYEBhE̐VTCYɍ킹
//=========================================================
void Application::AdjustViewToWindowSize() {

	sf::Vector2f worldPos_Before = _window.mapPixelToCoords( sf::Vector2i ( 0, 0 ) );

	sf::View view = _window.getView();
	view.setSize ( _window.getSize().x, _window.getSize().y );
	_window.setView( view );

	sf::Vector2f worldPos_After = _window.mapPixelToCoords( sf::Vector2i ( 0, 0 ) );

	sf::Vector2f currentCenter = view.getCenter();
	sf::Vector2f newCenter = currentCenter + (worldPos_Before - worldPos_After);
	view.setCenter ( newCenter );
	_window.setView( view );


	_defaultView.setSize ( _window.getSize().x, _window.getSize().y );
	currentCenter = _defaultView.getCenter();
	newCenter = currentCenter + (worldPos_Before - worldPos_After);
	_defaultView.setCenter ( newCenter );
}


//=========================================================
// 摜𒆉ɈړāAEBhE摜ƓTCYɂ
//=========================================================
void Application::FitWindowToImage() {

	///// ʂ̃TCY擾
	RECT rec;
	HWND hDeskWnd = GetDesktopWindow();  // fXNgbṽnh擾
	GetWindowRect ( hDeskWnd, &rec );    // fXNgbṽnh炻(ʂ)傫擾

	sf::Vector2u imageSize = _imageView->GetImageSize();

	_window.setSize ( imageSize ); // ʂ傫TCYɂ͂ȂȂ悤ɁASFML C𗘂ĂĂH
	AdjustViewToWindowSize();
	AdjustArrowPosition();

	sf::View view = _window.getView();
	_imageView->ZoomReset();

	view.setCenter ( 0, 0 );
	_window.setView(view);

	///// ʂ̒Ɉړ
	_window.setPosition ( 
		sf::Vector2i( 
			rec.right  / 2 - _window.getSize().x / 2, 
			rec.bottom / 2 - _window.getSize().y / 2
		)
	);

}
//=========================================================
// 摜𒆉Ɉړ
//=========================================================
void Application::CenterImage( bool zoomReset ) {

	sf::View view = _window.getView();

	if (zoomReset) {
		_imageView->ZoomReset();
	}

	view.setCenter ( 0, 0 );
	_window.setView(view);
}

//=========================================================
// tXN[ / EBhE ؂ւ
//=========================================================
void Application::Switch_FillScreenWindow () {

	HWND hWindow = _window.getSystemHandle();
	char buf[1024];
	GetWindowText ( hWindow, buf, 1024);
	string title = buf;

	///// tXN[EBhE[hɖ߂
	if ( _isFullScreen ) {

		std::vector<sf::VideoMode> videoModes = sf::VideoMode::getFullscreenModes();
		if ( videoModes.size() > 0 ) {

			unsigned int bitsPerPixel = 32; //videoModes[0].bitsPerPixel;

			int width  = _windowSize_FromFullScreen.x;
			int height = _windowSize_FromFullScreen.y;

			_window.create (sf::VideoMode ( width, height, bitsPerPixel), title, sf::Style::Default);
			_window.setFramerateLimit(60);
			_window.setVerticalSyncEnabled(true);
			_isFullScreen = false;
		}

	///// tXN[ɂ
	} else {

		_windowSize_FromFullScreen = _window.getSize();

		///// ʂ̃TCY擾
		RECT rec;
		HWND hDeskWnd = GetDesktopWindow();  // fXNgbṽnh擾
		GetWindowRect ( hDeskWnd, &rec );    // fXNgbṽnh炻(ʂ)傫擾

		_window.create (sf::VideoMode( rec.right, rec.bottom, 32), title, sf::Style::Fullscreen);
		//_window.create (sf::VideoMode( _windowSize_FromFullScreen.x, _windowSize_FromFullScreen.y, 32), title, sf::Style::Fullscreen);

		_window.setFramerateLimit(60);
		_window.setVerticalSyncEnabled(true);
		_isFullScreen = true;
	}

	CenterImage(false);
}
