//=========================================================
//
// ȈXMLp[T[NXi錾j
//
//=========================================================

#ifndef _NOTXML_
#define _NOTXML_

#include <vector>
#include <map>
#include <string>

using namespace std;


class NotXML {

public:

	//=========================================================
	// ^O\
	//=========================================================
	struct Tag {

		string name;                   // ^O
		string value;                  // l
		map<string, string> attribute; // 
		vector<Tag> childList;         // qvf

		Tag() {
			name  = "";
			value = "";
		}
	};
	
	//=========================================================
	// ǂݍ
	//=========================================================
	vector<Tag> Read     (string fileName);
	Tag         ReadRoot (string fileName);

	//=========================================================
	// Utilities
	//=========================================================
	static Tag GetTagFromName( const Tag& parent, string name ) {

		Tag result;

		for (unsigned int i = 0 ; i < parent.childList.size(); ++i) {

			if ( parent.childList[i].name == name) {
				result = parent.childList[i];
				break;
			}
		}

		return result;
	}
	static vector<Tag> GetTagListFromName( const Tag& parent, string name ) {

		vector<Tag> result;

		for (unsigned int i = 0 ; i < parent.childList.size(); ++i) {

			if ( parent.childList[i].name == name) {
				result.push_back( parent.childList[i] );
			}
		}

		return result;
	}
	static string GetAttribute( const Tag& tag, string name, string defaultValue = "" ) {

		string result = defaultValue;

		if (tag.attribute.find(name) != tag.attribute.end()) {
			result = tag.attribute.find(name)->second;
		}

		return result;
	}

private:

	///// ^O̎ށiǂݎ蒆pj
	enum PURE_TAG_TYPE {

		NOT_PURE_TAG_TYPE,     // l
		OPEN,    // Jn^O    <***>
		CLOSE,   // ^O    </***>
		EMPTY,   // vf^O  <***/>
		COMMENT, // Rg    <!-- ***  -->

		PROCESS, //     <?***?> Processing Instruction
		DOCTYPE, // DOCTYPE錾 <!DOCTYPE ****/>

		VALUE    // l          LȊOi^Oł͂Ȃj
	};


	//=========================================================
	// t@Cǂݍŕɂ
	//=========================================================
	string ReadFile_toString(string fileName);

	//=========================================================
	// 񂩂^Oۂӏ𒊏o
	//=========================================================
	vector<string> Parse_PureTagList(string str);

	//=========================================================
	// ^O̎ނ𔻕ʂ
	//=========================================================
	PURE_TAG_TYPE JadgePureTag( string pureTag );

	//=========================================================
	// 
	//=========================================================
	map<string, string> GetAttribute(string str);

	//=========================================================
	// ^OƂĂ̏擾
	//=========================================================
	Tag GetTagInfo(string str, PURE_TAG_TYPE type);

	//=========================================================
	// ^OԂ̍\
	//=========================================================
	vector<Tag> Parse(vector<string> pureTagList);

	//=========================================================
	// OTrim
	//yz
	// string
	//y߂lz
	// O̔pXy[XA\nA\rA\t 菜
	//=========================================================
	string Trim(const string &str);
};
#endif




