//=========================================================
//
// Utils_Cal (implement)
//
//=========================================================

#include "StdAfx.h"
#include "Utils_Cal.h"
#include<math.h>
#include <stdarg.h>

//=========================================================
// From -> To with the distance
//=========================================================
//sf::Vector2f Utils_Cal::MoveTo ( sf::Vector2f from, sf::Vector2f to, float distance ) {
pair<float, float> Utils_Cal::MoveTo ( float from_x, float from_y, float to_x, float to_y, float distance ) {

	//sf::Vector2f result = from;
	pair<float, float> result( from_x, from_y );


	float d =  sqrt( pow(to_x - from_x, 2) + pow(to_y - from_y, 2) );

	float rate = ( d != 0.0f ) ? (distance / d) : 0.0f;

	result.first  += (to_x - from_x) * rate;
	result.second += (to_y - from_y) * rate;
	

	// Exceed
	if (from_x < to_x) {
		if ( to_x < result.first) {
			result.first  = to_x;
			result.second = to_y;
		}
	}
	if (from_x > to_x) {
		if ( to_x > result.first) {
			result.first  = to_x;
			result.second = to_y;
		}
	}
	if (from_y < to_y) {
		if ( to_y < result.second) {
			result.first  = to_x;
			result.second = to_y;
		}
	}
	if (from_y > to_y) {
		if ( to_y > result.second) {
			result.first  = to_x;
			result.second = to_y;
		}
	}
	

	return result;
}

//=========================================================
// Get Distance
//=========================================================
//float Utils_Cal::GetDistance ( sf::Vector2f from, sf::Vector2f to ) {
float Utils_Cal::GetDistance ( float from_x, float from_y,  float to_x, float to_y) {

	float result = 0.0f;

	result =  sqrt( pow(to_x - from_x, 2) + pow(to_y - from_y, 2) );
 
	return result;

}

//=========================================================
// Nearlize
//=========================================================
float Utils_Cal::Nearlize( float from, float to, float distance ) {

	float result = from;

	if ( from > to ) {

		result -= distance;

		if (result < to) {
			result = to;
		}
	}
	else if ( result < to ) {

		result += distance;

		if (result > to) {
			result = to;
		}
	} 

	return result;
}

//=========================================================
// ߂
//=========================================================
int Utils_Cal::Sign( int a ) {

	int result = 0;

	if (a < 0) {
		result = -1;
	}
	else if (a > 0) {
		result = 1;
	}

	return result;

}

//=========================================================
// intpabs
//=========================================================
unsigned int Utils_Cal::Abs( int a, int b ) {

	unsigned int result = 0;

	if ( a > b ) {
		result = a - b;
	}
	else if ( b > a ) {
		result = b - a;
	}

	return result;
}
unsigned int Utils_Cal::Abs( int a ) {

	unsigned int result = 0;

	if ( a > 0 ) {
		result = a;
	}
	else if ( a < 0 ) {
		result = -a;
	}

	return result;
}

//=========================================================
// intppow
// a^b
//=========================================================
int Utils_Cal::Pow(int a, int b) {

	int result = 1;

	for (int i = 0; i < b; ++i) {

		result *= a;
	}

	return result;
}

//=========================================================
// 
//=========================================================
int Utils_Cal::GetRandom( int max ) {

	/*
		max ͊܂܂Ȃ
	*/

	///// 1ȏɂĂˁB
	if (max <= 0) {
		return 0;
	}


	//int result = rand()%max;
	int result = genrand_int31() % max;

	return result;
}
int Utils_Cal::GerRandom( int max ) {
	return GetRandom( max );
}

//==========================================================
// RCgX
// lot / all łāA肪o true
//==========================================================
bool Utils_Cal::MultipleCoinToss ( int lot, int all ) {

	bool result = false;

	result = GerRandom ( all ) < lot;

	return result;
}

//=========================================================
// Permutation
//yz
// left o right
//=========================================================
int Utils_Cal::Permutation ( int left, int right ) {

	int result = 1;

	for (int i = 0; i < right; ++i) {

		result *= (left - i);

	}

	return result;
}

//=========================================================
// ϒŁAől`FbN
//yz
// argNum ̌u argNum ̐̒Łv
//yʁz
// ŏ̈őlAtrue
//=========================================================
bool Utils_Cal::IsMax ( int argNum, ... ) {

	bool result = true;

	va_list args;

	va_start(args, argNum);

	// ŏ̈
	int firstArg;

	for (int i = 0; i < argNum; ++i) {

		// ԂɎ󂯎
		int iVal = va_arg(args, int);

		// ŏ͔̈rΏ
		if ( i == 0 ) {
			firstArg = iVal;

		// QԖڈȍ~̈Aŏ̈r
		} else {

			if ( iVal > firstArg ) {
				result = false;
				break;
			}
		}
	}

	va_end(args);

	return result;
}


//=========================================================
// dȂŗ
//=========================================================
void Utils_Cal::GetRandom_WithoutDuplicate ( set<int> &result, unsigned int n, int min, int max ) {

	// ʗpϐNAĂ܂܂H
	result.clear();

	// w̌ɂȂ܂ŌJԂB
	while ( result.size() < n ) {

		// т
		int lot = Utils_Cal::GerRandom( max-min ) + min;

		// ȍꍇ̂݁AʂɉB
		if ( result.find( lot ) ==  result.end()) {

			result.insert ( lot );
		}
	}
}

//==========================================================
// ԂɓĂ
// ^܂ނǂ true Ŋ܂
//==========================================================
bool Utils_Cal::IsBetween( int thisValue, int a, int b, bool isOverIncluded ) {

	bool result = false;

	int bigger  = ( a < b ) ? b : a;
	int smaller = ( a < b ) ? a : b;

	if ( smaller < thisValue && thisValue < bigger ) {

		result = true;

	} else {

		if (isOverIncluded) {

			if ( thisValue == a || thisValue == b ) {
				result = true;
			}
		}
	}

	return result;
}
//=========================================================
// ȎľܓƂlɊۂ߂
//=========================================================
void Utils_Cal::RoundWildly ( float & value ) {

	int a = value;
	value = a;
}

