//=========================================================
//
// Util_Convert (declare)
//
//=========================================================

#include "StdAfx.h"
#include "Utils_Convert.h"
#include "Utils_String.h"

//=========================================================
// string -> int
//=========================================================
int Utils_Convert::String_to_Int( string str, int defaultValue ) {

	if (str == "") {
		return defaultValue;
	}

	int result = 0;
	sscanf(str.c_str(), "%d", &result);
	return result;
}

//=========================================================
// int -> string
//=========================================================
string Utils_Convert::Int_to_String( int arg ) {

	string result = "";

	char buf[1024];
	sprintf( buf, "%d", arg );

	result = buf;

	return result;
}


//=========================================================
// string -> float
//=========================================================
float Utils_Convert::String_to_Float( string str, float defaultValue ) {

	if (str == "") {	
		return defaultValue;
	}

	float result = 0;
	sscanf(str.c_str(), "%f", &result);
	return result;
}


/*
//=========================================================
//   sf::Color
//=========================================================
sf::Color Utils_Convert::String_to_sfColor(string str, string splitter) {

	sf::Color result;

	vector<string> list = Utils_String::Split( str, splitter );

	///// number of elements is 4 :: with alpha
	if (list.size() == 4) {

		result.r = Utils_Convert::String_to_Int ( list[0] );
		result.g = Utils_Convert::String_to_Int ( list[1] );
		result.b = Utils_Convert::String_to_Int ( list[2] );
		result.a = Utils_Convert::String_to_Int ( list[3] );

	///// number of elements is 3 :: without alpha
	} else if (list.size() == 3) {

		result.r = Utils_Convert::String_to_Int ( list[0] );
		result.g = Utils_Convert::String_to_Int ( list[1] );
		result.b = Utils_Convert::String_to_Int ( list[2] );

	///// Invalid argument
	} else {
		// anything error processing?
	}

	return result;
}
*/

//==========================================================
// string -> bool
//==========================================================
bool Utils_Convert::String_to_bool( string str ) {

	bool result = false;

	if      ( str == "true") { result = true;}
	else if ( str == "false") { result = false;}
	else if ( str == "on") { result = true;}
	else if ( str == "off") { result = false;}
	else if ( str == "yes") { result = true;}
	else if ( str == "no") { result = false;}
	else if ( str == "ok") { result = true;}
	else if ( str == "ng") { result = false;}
	else if ( str == "1") { result = true;}
	else if ( str == "0") { result = false;}

	else if ( str == "TRUE") { result = true;}
	else if ( str == "FALSE") { result = false;}
	else if ( str == "ON") { result = true;}
	else if ( str == "OFF") { result = false;}
	else if ( str == "YES") { result = true;}
	else if ( str == "NO") { result = false;}
	else if ( str == "OK") { result = true;}
	else if ( str == "NG") { result = false;}


	return result;
}
//==========================================================
// bool -> string
//==========================================================
string Utils_Convert::Bool_to_string( bool arg ) {

	return ( (arg)?"true":"false" );
}




//=========================================================
// map < string, string > -> string
//=========================================================
string Utils_Convert::map_string_string_to_string ( map < string, string > src ) {

	///// ȂŁB
	if ( src.size() == 0 ) {
		return "";
	}

	/*
		OAL[̒ƒl݂̒ɂȂl̗Bu,v؂B
		u/voAOIB
		
		܂ÓAƁAu,vƁu/vȊO͏oĂȂƂۏ؂ĂB

		㔼́AL[ƒl݂ɂȂ́B
		Zp[^ȂɂȂAȂB
		O̐ƂɁA؂蕪ĂB

	*/

	string result = "";

	///// O㔼B
	string firstHalf  = "";
	string secondHalf = "";


	for ( map<string, string>::iterator it = src.begin(); it != src.end(); ++it ) {

		string key   = it->first;
		string value = it->second;

		// 㔼ɂ́A݂ɂȂĂB
		secondHalf += key + value;

		string keyLength   = Int_to_String ( key.size() );
		string valueLength = Int_to_String ( value.size() );

		// ŏȂȂAOƂ̋؂ƂāAu,vPĂB
		if ( firstHalf != "" ) {
			firstHalf += ",";
		}

		// OA㔼𓱂āB
		firstHalf += keyLength + "," + valueLength;
	}

	// Ȃ̂łˁBB
	result = firstHalf + "/" + secondHalf;

	return result;
}

//=========================================================
// string -> map < string, string >
//=========================================================
 map < string, string > Utils_Convert::string_to_map_string_string ( string src ) {

	map < string, string > result;

	///// ȂŁB
	if ( src == "" ) {
		return result;
	}

	///// ܂͑Oƌ㔼𕪂܂傤B
	string firstHalf  = "";
	string secondHalf = "";
	{
		vector<string> temp = Utils_String::Split ( src, "/" );

		firstHalf  = temp[0];
		//secondHalf = ( temp.size() >= 2 ) ? temp[1] : ""; // 
		secondHalf = ( src.size() > firstHalf.size() + 1 ) ? src.substr ( firstHalf.size() + 1 ) : "";
	}

	///// ȌAl̃XgƂ܂傤B
	vector<int> lengthInformationList;
	{
		vector<string> temp = Utils_String::Split ( firstHalf, "," );

		for ( unsigned int i = 0; i < temp.size(); ++i ) {

			lengthInformationList.push_back ( String_to_Int ( temp[i] ) );
		}
	}

	string sub = secondHalf.substr(0, 10);

	///// 㔼́F
	int currentCursorPos = 0;
	vector < string > secondHalfAnalysed;
	for ( unsigned int i = 0; i < lengthInformationList.size(); ++i ) {

		string sub = secondHalf.substr ( currentCursorPos, lengthInformationList[i] );

		secondHalfAnalysed.push_back ( sub );

		currentCursorPos += lengthInformationList[i];
	}

	// ɁAgɓI
	for ( unsigned int i = 0; i < secondHalfAnalysed.size(); i += 2 ) {

		string key   = secondHalfAnalysed[i];
		string value = ( (i + 1) < secondHalfAnalysed.size() ) ? secondHalfAnalysed[i + 1] : "";

		result[key] = value;
	}

	 return result;
 }

//=========================================================
// map < string, string > -> string
//=========================================================
string Utils_Convert::pairList_string_string_to_string ( vector < pair < string, string > > src ) {

	///// Ȃ
	if ( src.size() == 0 ) {
		return "";
	}

	string result = "";

	///// O㔼B
	string firstHalf  = "";
	string secondHalf = "";

	for ( unsigned int i = 0; i < src.size(); ++i) {

		string key   = src[i].first;
		string value = src[i].second;

		// 㔼ɂ́A݂ɂȂĂB
		secondHalf += key + value;

		string keyLength   = Int_to_String ( key.size() );
		string valueLength = Int_to_String ( value.size() );

		// ŏȂȂAOƂ̋؂ƂāAu,vPĂB
		if ( firstHalf != "" ) {
			firstHalf += ",";
		}

		// OA㔼𓱂āB
		firstHalf += keyLength + "," + valueLength;
	}

	// Ȃ̂łˁBB
	result = firstHalf + "/" + secondHalf;

	return result;

}

//=========================================================
// string -> vector < pair < string, string > >
//=========================================================
vector < pair <string, string > > Utils_Convert::string_to_pairList_string_string ( string src ) {

	vector < pair <string, string > > result;

	///// Ȃ
	if ( src == "" ) {
		return result;
	}

	///// ܂͑Oƌ㔼𕪂܂傤B
	string firstHalf  = "";
	string secondHalf = "";
	{
		vector<string> temp = Utils_String::Split ( src, "/" );

		firstHalf  = temp[0];
		//secondHalf = ( temp.size() >= 2 ) ? temp[1] : ""; // 
		secondHalf = ( src.size() > firstHalf.size() + 1 ) ? src.substr ( firstHalf.size() + 1 ) : "";
	}

	///// ȌAl̃XgƂ܂傤B
	vector<int> lengthInformationList;
	{
		vector<string> temp = Utils_String::Split ( firstHalf, "," );

		for ( unsigned int i = 0; i < temp.size(); ++i ) {

			lengthInformationList.push_back ( String_to_Int ( temp[i] ) );
		}
	}

	//string sub = secondHalf.substr(0, 10);

	///// 㔼́F
	int currentCursorPos = 0;
	vector < string > secondHalfAnalysed;
	for ( unsigned int i = 0; i < lengthInformationList.size(); ++i ) {

		string sub = secondHalf.substr ( currentCursorPos, lengthInformationList[i] );

		secondHalfAnalysed.push_back ( sub );

		currentCursorPos += lengthInformationList[i];
	}

	// ɁAgɓI
	for ( unsigned int i = 0; i < secondHalfAnalysed.size(); i += 2 ) {

		string key   = secondHalfAnalysed[i];
		string value = ( (i + 1) < secondHalfAnalysed.size() ) ? secondHalfAnalysed[i + 1] : "";

		pair < string, string > p ( key, value );

		result.push_back ( p );
	}

	return result;
}

//=========================================================
// string -> map<string, string>
//=========================================================
map<string, string> Utils_Convert::ReadStringAsMap ( string &src, string delimiter, string equal) {

	map<string, string> result;

	vector<string> elements = Utils_String::Split ( src, delimiter );
	for ( unsigned int i = 0; i < elements.size(); ++i ) {

		string element = elements[i];

		vector<string> analyzed = Utils_String::Split ( element, equal );

		string key   = ( analyzed.size() >= 1) ? analyzed[0]: "";
		string value = ( analyzed.size() >= 2) ? analyzed[1]: "";;

		result.insert( pair<string, string>( key, value ) );
	}

	return result;
}

//=========================================================
// vector<string> -> comma separated string
//=========================================================
string Utils_Convert::vectorString_to_string ( vector<string> &list, string delimiter) {

	string result = "";

	for ( unsigned  int i = 0; i < list.size(); ++i) {

		if ( i > 0 ) {
			result += delimiter;
		}

		result += list[i];
	}

	return result;
}

//=========================================================
// vector<int> -> comma separated string
//=========================================================
string Utils_Convert::vectorInt_to_string ( vector<int> &list, string delimiter) {

	string result = "";


	for ( unsigned  int i = 0; i < list.size(); ++i) {

		if ( i > 0 ) {
			result += delimiter;
		}

		result += Int_to_String ( list[i] );
	}

	return result;
}